unit Frmdistr;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, ExtCtrls, StdCtrls, RChart, Vector, Spin, NumLab;

type
  TFrmMain = class(TForm)
    Panel1: TPanel;
    SBExit: TSpeedButton;
    RChart1: TRChart;
    SBarMean2: TScrollBar;
    SBarStdDev2: TScrollBar;
    SBSetNormalD: TSpeedButton;
    SButLeptoKD: TSpeedButton;
    SButPlatyKD: TSpeedButton;
    SButLeftSkew: TSpeedButton;
    SButRightSKew: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    SButCalcRandNums: TSpeedButton;
    SBarMean1: TScrollBar;
    SBarStdDev1: TScrollBar;
    SBarHRatio: TScrollBar;
    Label4: TLabel;
    Label5: TLabel;
    SButBiModal: TSpeedButton;
    Label6: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    SButEditDistri: TSpeedButton;
    SButLoadDistri: TSpeedButton;
    SButAbout: TSpeedButton;
    Bevel3: TBevel;
    Label7: TLabel;
    SButSaveDistri: TSpeedButton;
    SaveDialog1: TSaveDialog;
    NLabLowB: TNumLab;
    NLabHighB: TNumLab;
    NLabNumPnts: TNumLab;
    EdLowB: TEdit;
    SBarNumRandNum: TScrollBar;
    EdHighB: TEdit;
    Label8: TLabel;
    OpenDialog1: TOpenDialog;
    Bevel4: TBevel;
    SButHelp: TSpeedButton;
    procedure SBExitClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SBarMean2Change(Sender: TObject);
    procedure SBarStdDev2Change(Sender: TObject);
    procedure SBSetNormalDClick(Sender: TObject);
    procedure SButLeptoKDClick(Sender: TObject);
    procedure SButPlatyKDClick(Sender: TObject);
    procedure SButLeftSkewClick(Sender: TObject);
    procedure SButRightSKewClick(Sender: TObject);
    procedure SButCalcRandNumsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SBarMean1Change(Sender: TObject);
    procedure SBarStdDev1Change(Sender: TObject);
    procedure SBarHRatioChange(Sender: TObject);
    procedure SButBiModalClick(Sender: TObject);
    procedure SButEditDistriClick(Sender: TObject);
    procedure SButAboutClick(Sender: TObject);
    procedure NLabLowBClick(Sender: TObject);
    procedure EdLowBKeyPress(Sender: TObject; var Key: Char);
    procedure SBarNumRandNumChange(Sender: TObject);
    procedure EdHighBKeyPress(Sender: TObject; var Key: Char);
    procedure NLabHighBClick(Sender: TObject);
    procedure SButSaveDistriClick(Sender: TObject);
    procedure SButLoadDistriClick(Sender: TObject);
    procedure SButHelpClick(Sender: TObject);
  private
    procedure CalcandShowDistri;
    procedure ShowDistri;
    procedure AllPredefDistUp;
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}

uses
  frmedit, about, math1, math2;

const
  RGenResol = 500;
  RGenVersion = 'Version 1.0';

var
  Mean1, Mean2     : double;
  StdDev1, Stddev2 : double;
  HRatio           : double;
  RandGen          : TRandGen;
  NumRandNum       : longint;

(***************************************************************)
procedure TFrmMain.SBExitClick(Sender: TObject);
(***************************************************************)

begin
close;
end;

(***************************************************************)
procedure TFrmMain.AllPredefDistUp;
(***************************************************************)

begin
SBSetNormalD.Down := false;
SButLeptoKD.Down := false;
SButPlatyKD.Down := false;
SButLeftSkew.Down := false;
SButRightSKew.Down := false;
SButBiModal.Down := false;
end;

(***************************************************************)
procedure TFrmMain.ShowDistri;
(***************************************************************)

var
  i : longint;

begin
RChart1.ClearGraf;
RChart1.MoveTo (RandGen.LowBorder,0);
RChart1.DataColor := clBlue;
for i:=1 to RGenResol do
  RChart1.DrawTo (RandGen.Lambda[i],RandGen.Probability[i]);
RChart1.DrawTo (RandGen.HighBorder,0.0);
RChart1.ShowGraf;
end;

(***************************************************************)
procedure TFrmMain.CalcandShowDistri;
(***************************************************************)

var
  i    : longint;

begin
for i:=1 to RGenResol do
  begin
  RandGen.Probability[i] := (1-HRatio)*exp(-sqr(i-Mean1)/sqr(StdDev1)) +
                            HRatio*exp(-sqr(i-Mean2)/sqr(StdDev2));
  end;
RandGen.Normalize;
ShowDistri;
end;


(***************************************************************)
procedure TFrmMain.FormActivate(Sender: TObject);
(***************************************************************)

begin
Mean1 := 250;
Mean2 := 250;
StdDev1 := 100;
StdDev2 := 100;
HRatio := 0.5;
CalcandShowDistri;
{$IFNDEF DATALAB}
if Aboutbox.ShowModal = mrAbort then
  close;
{$ENDIF}
end;

(***************************************************************)
procedure TFrmMain.SBarMean2Change(Sender: TObject);
(***************************************************************)

begin
Mean2 := SBarMean2.Position;
CalcandShowDistri;
end;

(***************************************************************)
procedure TFrmMain.SBarStdDev2Change(Sender: TObject);
(***************************************************************)

begin
STdDev2 := SBarStdDev2.Position;
CalcandShowDistri;
end;

(***************************************************************)
procedure TFrmMain.SBSetNormalDClick(Sender: TObject);
(***************************************************************)

begin
SBarHRatio.Position := 0;
SBarStdDev1.Position := 100;
SBarMean1.Position := 250;
SBarStdDev2.Position := 100;
SBarMean2.Position := 250;
CalcandShowDistri;
end;

(***************************************************************)
procedure TFrmMain.SButLeptoKDClick(Sender: TObject);
(***************************************************************)

begin
SBarHRatio.Position := 50;
SBarStdDev1.Position := 60;
SBarMean1.Position := 250;
SBarStdDev2.Position := 21;
SBarMean2.Position := 250;
CalcandShowDistri;
end;

(***************************************************************)
procedure TFrmMain.SButPlatyKDClick(Sender: TObject);
(***************************************************************)

begin
SBarHRatio.Position := 50;
SBarStdDev1.Position := 60;
SBarMean1.Position := 205;
SBarStdDev2.Position := 60;
SBarMean2.Position := 295;
CalcandShowDistri;
end;

(***************************************************************)
procedure TFrmMain.SButBiModalClick(Sender: TObject);
(***************************************************************)

begin
SBarHRatio.Position := 65;
SBarStdDev1.Position := 50;
SBarMean1.Position := 170;
SBarStdDev2.Position := 40;
SBarMean2.Position := 330;
CalcandShowDistri;
end;



(***************************************************************)
procedure TFrmMain.SButLeftSkewClick(Sender: TObject);
(***************************************************************)

begin
SBarHRatio.Position := 50;
SBarStdDev1.Position := 55;
SBarMean1.Position := 230;
SBarStdDev2.Position := 32;
SBarMean2.Position := 270;
CalcandShowDistri;
end;

(***************************************************************)
procedure TFrmMain.SButRightSKewClick(Sender: TObject);
(***************************************************************)

begin
SBarHRatio.Position := 50;
SBarStdDev1.Position := 32;
SBarMean1.Position := 230;
SBarStdDev2.Position := 55;
SBarMean2.Position := 270;
CalcandShowDistri;
end;

(***************************************************************)
procedure TFrmMain.SButCalcRandNumsClick(Sender: TObject);
(***************************************************************)

var
  m, r  : double;
  i     : longint;
  idx   : integer;
  TFile : TextFile;
  Histo : array[0..RGenResol+1] of longint;
  MaxHisto : double;

begin
SaveDialog1.Filter := 'ASCII Format|*.asc';
SaveDialog1.Filename := 'unknown.asc';
if SaveDialog1.Execute then
  begin
  assignFile (TFile, SaveDialog1.Filename);
  rewrite (TFile);
  writeln (TFile, 'Random numbers generated by RandGen '+RGenVersion);
  writeln (TFile, '1',#9,'; # of columns');
  writeln (TFile, NumRandNum,#9,'; # of rows');
  writeln (TFile, 'false false false');
  for i:=0 to RGenResol+1 do
    Histo[i] := 0;
  MaxHisto := 0;
  ShowDistri;
  for i:=1 to NumRandNum do
    begin
    r := RandGen.Random;
    writeln (TFile, r:1:4);
    idx := RandGen.IndexOfLambda(r);
    inc (Histo[idx]);
    if NumRandNum > 999
      then m := (Histo[idx-1]+Histo[idx]+Histo[idx+1])/3
      else m := Histo[idx];
    if m > MaxHisto then
      MaxHisto := m;
    end;
  closeFile (Tfile);
  Rchart1.DataColor := TColor($FFe0c0);
  for i:=1 to RGenResol do
    RChart1.Line (RandGen.Lambda[i],0,RandGen.Lambda[i],Histo[i]/MaxHisto);
  RChart1.MoveTo (RandGen.LowBorder,0);
  RChart1.DataColor := clBlue;
  for i:=1 to RGenResol do
    RChart1.DrawTo (RandGen.Lambda[i],RandGen.Probability[i]);
  RChart1.DrawTo (RandGen.HighBorder,0.0);
  RChart1.ShowGraf;
  end;
end;

(***************************************************************)
procedure TFrmMain.FormCreate(Sender: TObject);
(***************************************************************)

begin
RandGen := TRandGen.Create;
RandGen.Resolution := RGenResol;
RandGen.LowBorder := -300;
RandGen.Highborder := 300;
NumRandNum := 500;
end;

(***************************************************************)
procedure TFrmMain.SBarMean1Change(Sender: TObject);
(***************************************************************)

begin
Mean1 := SBarMean1.Position;
CalcandShowDistri;
end;

(***************************************************************)
procedure TFrmMain.SBarStdDev1Change(Sender: TObject);
(***************************************************************)

begin
STdDev1 := SBarStdDev1.Position;
CalcandShowDistri;
end;

(***************************************************************)
procedure TFrmMain.SBarHRatioChange(Sender: TObject);
(***************************************************************)

begin
HRatio := SBarHRatio.Position/100;
CalcandShowDistri;
end;

(***************************************************************)
procedure TFrmMain.SButEditDistriClick(Sender: TObject);
(***************************************************************)

var
  i : integer;

begin
FrmEditDistri.NTabEd1.SuppressPaint := true;
FrmEditDistri.NTabEd1.NrOfRows := RGenResol;
for i:=1 to RGenResol do
  FrmEditDistri.NTabed1.Elem[1,i] := RandGen.Probability[i];
FrmEditDistri.NTabEd1.ColName[1] := 'Probability';
for i:=1 to RGenResol do
  FrmEditDistri.NTabEd1.RowName[i] := strf(RandGen.Lambda[i],1,2);
FrmEditDistri.NTabEd1.SuppressPaint := false;
FrmEditDistri.ShowModal;
for i:=1 to RGenResol do
  RandGen.Probability[i] := FrmEditDistri.NTabed1.Elem[1,i];
AllPredefDistUp;
ShowDistri;
end;

(***************************************************************)
procedure TFrmMain.SButAboutClick(Sender: TObject);
(***************************************************************)

begin
AboutBox.BButDisagree.Visible := false;
AboutBox.BButOK.Caption := 'Done';
AboutBox.Memo1.Lines[0] := '';
AboutBox.Memo1.Lines[1] := '         Info on RandGen';
Aboutbox.ShowModal;
end;

(***************************************************************)
procedure TFrmMain.NLabLowBClick(Sender: TObject);
(***************************************************************)

begin
EdLowB.Visible := true;
EdLowB.Text := ' '+strf(NLabLowB.Value,1,3);
EdLowB.SetFocus;
end;

(***************************************************************)
procedure TFrmMain.EdLowBKeyPress(Sender: TObject; var Key: Char);
(***************************************************************)

var
  rdummy : double;
  status : integer;

begin
if Key = #13 then
  begin
  EdLowB.Visible := false;
  val (EdLowB.Text,rdummy, status);
  if status = 0 then
    begin
    NLabLowB.Value := rdummy;
    RChart1.RangeLoX := rdummy;
    RandGen.LowBorder := rdummy;
    ShowDistri;
    end;
  end;
if Key = #27 then
  EdLowB.Visible := false;
end;

(***************************************************************)
procedure TFrmMain.SBarNumRandNumChange(Sender: TObject);
(***************************************************************)

const
  RNums : array[1..28] of longint =
           (1,2,3,5,7,
            10,15,20,30,50,75,
            100,150,200,300,500,750,
            1000,1500,2000,3000,5000,7500,
            10000,15000,20000,30000,50000);

begin
NLabNumPnts.Value := RNums[SBarNumRandNum.Position];
NumRandNum := RNums[SBarNumRandNum.Position];
end;

(***************************************************************)
procedure TFrmMain.EdHighBKeyPress(Sender: TObject; var Key: Char);
(***************************************************************)

var
  rdummy : double;
  status : integer;

begin
if Key = #13 then
  begin
  EdHighB.Visible := false;
  val (EdHighB.Text,rdummy, status);
  if status = 0 then
    begin
    NLabHighB.Value := rdummy;
    RandGen.HighBorder := rdummy;
    RChart1.RangeHiX := rdummy;
    ShowDistri;
    end;
  end;
if Key = #27 then
  EdHighB.Visible := false;
end;


(***************************************************************)
procedure TFrmMain.NLabHighBClick(Sender: TObject);
(***************************************************************)

begin
EdHighB.Visible := true;
EdHighB.Text := ' '+strf(NLabHighB.Value,1,3);
EdHighB.SetFocus;
end;

(***************************************************************)
procedure TFrmMain.SButSaveDistriClick(Sender: TObject);
(***************************************************************)

var
  TFile : TextFile;
  i     : integer;

begin
SaveDialog1.Filter := 'Random Number Distribution|*.rnd';
SaveDialog1.Filename := 'unknown.rnd';
if SaveDialog1.Execute then
  begin
  assignFile (TFile, SaveDialog1.Filename);
  rewrite (TFile);
  writeln (TFile, 'comment');
  writeln (TFile, RandGen.Resolution, #9, '; resolution of random generator');
  writeln (TFile, RandGen.LowBorder, #9, '; lower limit of random numbers');
  writeln (TFile, RandGen.HighBorder, #9, '; upper limit of random numbers');
  for i:=1 to RandGen.Resolution do
    begin
    if i=1
      then writeln (TFile, RandGen.Probability[i], #9, '; reference points ...')
      else writeln (TFile, RandGen.Probability[i]);
    end;
  closeFile (TFile);
  end;
end;

(***************************************************************)
procedure TFrmMain.SButLoadDistriClick(Sender: TObject);
(***************************************************************)

var
  TFile : TextFile;
  i     : integer;
  auxres: integer;
  rdummy: double;
  astr  : string;

begin
OpenDialog1.Filter := 'Random Number Distribution|*.rnd';
OpenDialog1.Filename := 'unknown.rnd';
if OpenDialog1.Execute then
  begin
  assignFile (TFile, OpenDialog1.Filename);
  reset (TFile);
  readln (TFile, astr);
  readln (TFile, auxres);
  RandGen.Resolution := auxres;
  readln (TFile, rdummy);
  RandGen.LowBorder := rdummy;
  readln (TFile, rdummy);
  RandGen.HighBorder := rdummy;
  for i:=1 to auxres do
    begin
    readln (TFile, rdummy);
    RandGen.Probability[i] := rdummy;
    end;
  closeFile (TFile);
  RandGen.Normalize;
  NLabLowB.Value := RandGen.LowBorder;
  RChart1.RangeLoX := RandGen.LowBorder;
  NLabHighB.Value := RandGen.HighBorder;
  RChart1.RangeHiX := RandGen.HighBorder;
  AllPredefDistUp;
  ShowDistri;
  end;
end;

(***************************************************************)
procedure TFrmMain.SButHelpClick(Sender: TObject);
(***************************************************************)

begin
Application.HelpFile := 'RANDGEN.HLP';
Application.HelpJump ('');
end;

end.
